package com.vivek.marriage_center_collection;

import android.app.Activity;
import android.app.Dialog;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.Typeface;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.LinearLayout.LayoutParams;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

import com.vivek.marriage_center_collection.R.color;

public class ScoreBoard extends Activity {

	int number_of_player;
	String[] player_name;
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
		finish();
	}


	TextView[] TVheader;
	Typeface face,face1;
	int round_number;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.scoreboard);
		
		number_of_player = valuebook.no_of_player;
		player_name = new String[number_of_player];
		
		player_name = valuebook.get_playername();
		
		face=Typeface.createFromAsset(getAssets(), "fonts/Ubuntu-Bold.ttf");
		face1=Typeface.createFromAsset(getAssets(), "fonts/Ubuntu-Regular.ttf");
		
		TextView title = (TextView) findViewById(R.id.title);
		TextView scoreboard_title = (TextView) findViewById(R.id.Scoreboard_title);
		Button endgame = (Button) findViewById(R.id.Button_endgame);
		Button addscore = (Button) findViewById(R.id.Button_addscore); 
		TextView roundTV = (TextView) findViewById(R.id.roundTV);
		TextView TotalTV = (TextView) findViewById(R.id.totalTV);
		
		roundTV.setTypeface(face);
		TotalTV.setTypeface(face);
						
		title.setTypeface(face);
		scoreboard_title.setTypeface(face);
		endgame.setTypeface(face);
		addscore.setTypeface(face);
				
		/****************************scoreboard heading works**********************************************/
		TableRow row_header = (TableRow) findViewById(R.id.row_header);
		
		TVheader = new TextView[number_of_player];
		
		for(int i=0; i<number_of_player; i++)
		{
			TVheader[i] = new TextView(this);
				TVheader[i].setText(player_name[i]);
				TVheader[i].setLayoutParams(new TableRow.LayoutParams(0, 25,1f));
				TVheader[i].setTextColor(Color.BLACK);
				TVheader[i].setTypeface(face);
				TVheader[i].setTextSize(13);
				TVheader[i].setGravity(Gravity.CENTER);
							
			row_header.addView(TVheader[i]);
		}
		
		/****************************scoreboard body works**********************************************/
		
		round_number = valuebook.round;
		
		CenterCollectionDatabase db = new CenterCollectionDatabase(ScoreBoard.this);
		db.open();
		
		
		int num = db.ifdata_in_table();
			
		if(num>0)
		{
			float point = valuebook.valuepoint;
			float[][] amount_ofplayer= new float[round_number][number_of_player] ;
			
			for(int i=1; i<round_number; i++)
			{
				int winnerID_ofround = db.check_winner(i);				
				int totalmaal_ofround = db.get_total_maal(i);	
				
					for(int j=0; j<number_of_player; j++)
					{
						int point_of_player = db.point_of_player((i), j);
						int maal_of_player = db.maal_of_player((i), j);
						
						if( j != winnerID_ofround){
							
							amount_ofplayer[i][j] = (maal_of_player * number_of_player -totalmaal_ofround-point_of_player)*point;
						}
						
					}
					amount_ofplayer[i][winnerID_ofround] = calculate_amount_of_winner(amount_ofplayer, winnerID_ofround,i);
				
			}	
			int[] winnerlist = db.getting_all_winner();
			embedd_to_scoreboard(amount_ofplayer, winnerlist);
			display_footer(amount_ofplayer);
			
			
		}
			
		db.close();
		
		
		
		/****************************scoreboard Footer work**********************************************/

		
		
		
		/****************************Action work for Add point and End game Buttons**********************/
		
		addscore.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				
				Intent intent = new Intent(ScoreBoard.this, ScoreEntry.class);
				startActivity(intent);
				overridePendingTransition(R.anim.in_from_right, R.anim.out_to_left);
				finish();
				
			}
		});
		
		endgame.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				
				final Dialog dialog = new Dialog(ScoreBoard.this);
				dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
				dialog.setContentView(R.layout.endup_dialog);
				
				TextView up_notice = (TextView) dialog.findViewById(R.id.up_notice);
				TextView down_notice = (TextView) dialog.findViewById(R.id.down_notice);
				
				up_notice.setTypeface(face);
				down_notice.setTypeface(face1);
				
				Button quit = (Button) dialog.findViewById(R.id.QUIT);
				Button cancel = (Button) dialog.findViewById(R.id.CANCEL);
				Button continue_later = (Button) dialog.findViewById(R.id.CONTINUE_LATER);
				
				quit.setTypeface(face1);
				cancel.setTypeface(face1);
				continue_later.setTypeface(face1);
				
				quit.setOnClickListener(new View.OnClickListener() {
					
					public void onClick(View v) {
					
						CenterCollectionDatabase db = new CenterCollectionDatabase(ScoreBoard.this);
						db.open();
							db.delete_database();
						db.close();
						dialog.dismiss();
						finish();
						
					}
				});
				
				cancel.setOnClickListener(new View.OnClickListener() {
					
					public void onClick(View v) {
						dialog.dismiss();
						
					}
				});
				
				continue_later.setOnClickListener(new View.OnClickListener() {
					
					public void onClick(View v) {
						
						finish();
						dialog.dismiss();
					}
				});
				
				dialog.show();
				
			}
		});
	}

	private void embedd_to_scoreboard(float[][] amount_ofplayer, int[] winnerlist) {
		
		TableLayout tablelayout = (TableLayout)findViewById(R.id.scoreboard_body);
		tablelayout.removeAllViews();
		
		TextView[][] score = new TextView[round_number][number_of_player];
		TableRow[] dyn_row = new TableRow[round_number];
		TextView[] roundView = new TextView[round_number];
		
		
		for(int i = 1; i<round_number; i++)
		{
			dyn_row[i] = new TableRow(this);
				dyn_row[i].setLayoutParams(new TableLayout.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT));
			
			roundView[i] = new TextView(this);
				roundView[i].setText(String.valueOf(i));
				roundView[i].setPadding(8, 0, 0, 0);
				roundView[i].setLayoutParams(new TableRow.LayoutParams(0,35,1f));
				roundView[i].setTextColor(Color.rgb(68, 43, (int) 0F));
				roundView[i].setTypeface(face);
				roundView[i].setTextSize(15);
				//roundView[i].setBackgroundResource(R.drawable.tablegrid);
			
			dyn_row[i].addView(roundView[i]);
			
			for(int j=0; j<number_of_player; j++)
			{
				score[i][j] = new TextView(this);
					score[i][j].setText(String.valueOf(String.valueOf(amount_ofplayer[i][j])));
					score[i][j].setLayoutParams(new TableRow.LayoutParams(0,35,1f));
					score[i][j].setTextColor(Color.rgb(00, 00, 00));
					score[i][j].setTypeface(face);
					score[i][j].setGravity(Gravity.CENTER);
					score[i][j].setTextSize(15);
					//score[i][j].setBackgroundResource(R.drawable.tablegrid);
				
				dyn_row[i].addView(score[i][j]);
				
			}
			tablelayout.addView(dyn_row[i]);
		}
		
		for(int i = 1; i<round_number; i++)
		{
			score[i][winnerlist[i-1]].setBackgroundDrawable(getResources().getDrawable(R.drawable.winnerred));
			score[i][winnerlist[i-1]].setTextColor(Color.rgb(255, 255, 255));
		}
		
		
	}
	
	private void display_footer(float[][] amount_ofplayer) {
		
//		TableLayout footer = (TableLayout) findViewById(R.id.scoreboard_footer);
		TableRow footer_row = (TableRow)findViewById(R.id.row_footer);
		
		TextView[] total_score = new TextView[number_of_player];
		float[] total_amt = new float[number_of_player];
		
		for(int i=0; i<number_of_player; i++)
		{
			for(int j=1; j<round_number; j++)
			{
				total_amt[i] = total_amt[i] + amount_ofplayer[j][i];
			}
			
			total_score[i] = new TextView(this);
				total_score[i].setText(String.valueOf(total_amt[i]));
				total_score[i].setLayoutParams(new TableRow.LayoutParams(0,35,1f));
				total_score[i].setTextColor(color.brown);
				total_score[i].setTypeface(face);
				total_score[i].setGravity(Gravity.CENTER);
				total_score[i].setTextSize(19);
			
			footer_row.addView(total_score[i]);
				
		}
		
		int highest_scorer =  get_higest(total_amt);
			try{
				total_score[highest_scorer].setBackgroundColor(Color.rgb(222, 71, 60));
				total_score[highest_scorer].setTextColor(Color.rgb(255, 255, 255));
			}catch (ArrayIndexOutOfBoundsException e) {
				Log.i("array out of bound exception", e.toString());
			}
			
		
		
		
	}


	public float calculate_amount_of_winner(float[][] amount, int winnerId, int round)
	{
		float amount_of_winner = 0;
		int negative = -1;
		for(int i=0; i<number_of_player; i++)
		{
			if(i!=winnerId)
			{
				amount_of_winner= amount_of_winner + amount[round][i];
			}
						
		}
		float winner_amt = amount_of_winner*negative;
		return (winner_amt);
	}
	
	public int get_higest(float[] amount)
	{
		float a =0;
		int c=0;
		int size = amount.length;
		Log.i("Size of amount", String.valueOf(size));
		for(int i=0; i<size; i++)
		{
			if(amount[i]>a)
			{
				a=amount[i];
				c=i;
			}
		}
		Log.i("heighest position", String.valueOf(c));
		return c;	
	}


	@Override
	public void onBackPressed() {
		// TODO Auto-generated method stub
		final Dialog dialog = new Dialog(ScoreBoard.this);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setContentView(R.layout.endup_dialog);
		
		TextView up_notice = (TextView) dialog.findViewById(R.id.up_notice);
		TextView down_notice = (TextView) dialog.findViewById(R.id.down_notice);
		
		up_notice.setTypeface(face);
		down_notice.setTypeface(face1);
		
		Button quit = (Button) dialog.findViewById(R.id.QUIT);
		Button cancel = (Button) dialog.findViewById(R.id.CANCEL);
		Button continue_later = (Button) dialog.findViewById(R.id.CONTINUE_LATER);
		
		quit.setTypeface(face1);
		cancel.setTypeface(face1);
		continue_later.setTypeface(face1);
		
		quit.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
			
				CenterCollectionDatabase db = new CenterCollectionDatabase(ScoreBoard.this);
				db.open();
					db.delete_database();
				db.close();
				dialog.dismiss();
				finish();
				
			}
		});
		
		cancel.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				dialog.dismiss();
				
			}
		});
		
		continue_later.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				
				finish();
				
			}
		});
		
		dialog.show();
	}
	
}
