package com.vivek.marriage_center_collection;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.database.SQLException;
import android.graphics.Color;
import android.graphics.Typeface;
import android.os.Bundle;
import android.text.InputType;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.LinearLayout.LayoutParams;
import android.widget.RadioButton;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class ScoreEntry extends Activity {

	int number_of_player;
	String[] player_name;
	EditText[] ETpoint;
	EditText[] ETmaal;
	int selectedID;
	
	Spinner[] PointSpinner;
	
	List<RadioButton> radioButtons;
	
	
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
		finish();
	}
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.point_entry);
		
		number_of_player = valuebook.no_of_player;
		player_name = new String[number_of_player];
		player_name = valuebook.get_playername();
		
		Typeface face=Typeface.createFromAsset(getAssets(), "fonts/Ubuntu-Bold.ttf");
		Typeface face1=Typeface.createFromAsset(getAssets(), "fonts/Ubuntu-Regular.ttf");
		
		TextView title = (TextView) findViewById(R.id.title);
		TextView info = (TextView) findViewById(R.id.TVinfo);
		Button save = (Button) findViewById(R.id.saveButton);
		
		title.setTypeface(face);
		info.setTypeface(face1);
		save.setTypeface(face);
		
		LinearLayout linearlayout = (LinearLayout) findViewById(R.id.player_point_entry);
		
		TextView[] TVplayer = new TextView[number_of_player];
		ETpoint = new EditText[number_of_player];
		ETmaal = new EditText[number_of_player];
		RadioButton[] won = new RadioButton[number_of_player];
		
		PointSpinner = new Spinner[number_of_player];			
		List<String> point_list = new ArrayList<String>();
		point_list.add("0");
		point_list.add(String.valueOf(valuebook.lowerlimit));
		point_list.add(String.valueOf(valuebook.upperlimit));
		
		ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, point_list);
		dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		
		LinearLayout[] dyn_linearLayout = new LinearLayout[number_of_player];
		
		radioButtons = new ArrayList<RadioButton>();

		for(int i =0; i<number_of_player; i++)
		{
			dyn_linearLayout[i] = new LinearLayout(this);
			dyn_linearLayout[i].setPadding(5, 5, 5, 5);
			dyn_linearLayout[i].setOrientation(LinearLayout.HORIZONTAL);
			dyn_linearLayout[i].setLayoutParams(new LinearLayout.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT));
			
				TVplayer[i] = new TextView(this);
					TVplayer[i].setText(player_name[i]);
					TVplayer[i].setTypeface(face);
					TVplayer[i].setTextSize(15);
					TVplayer[i].setTextColor(Color.BLACK);
					TVplayer[i].setLines(1);
					TVplayer[i].setLayoutParams(new LinearLayout.LayoutParams(70, LayoutParams.WRAP_CONTENT,1f));
					
				ETpoint[i] = new EditText(this);
					ETpoint[i].setHint("Point");
					ETpoint[i].setInputType(InputType.TYPE_CLASS_NUMBER);
					ETpoint[i].setLayoutParams(new LinearLayout.LayoutParams(70, LayoutParams.WRAP_CONTENT, 1f));
										
					
				PointSpinner[i] = new Spinner(this);
					PointSpinner[i].setLayoutParams(new LinearLayout.LayoutParams(90, LayoutParams.WRAP_CONTENT, 1f));
					PointSpinner[i].setAdapter(dataAdapter);
					
					
				ETmaal[i] = new EditText(this);
					ETmaal[i].setHint("Maal");
					ETmaal[i].setInputType(InputType.TYPE_CLASS_NUMBER);
					ETmaal[i].setLayoutParams(new LinearLayout.LayoutParams(70, LayoutParams.WRAP_CONTENT, 1f));
					
				won[i] = new RadioButton(this);
					won[i].setLayoutParams(new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT));
					won[i].setChecked(false);
					won[i].setId(100+i);
										
				radioButtons.add(won[i]);
				
				dyn_linearLayout[i].addView(TVplayer[i]);
				
				if(valuebook.gamemode==0) //free
				{
					dyn_linearLayout[i].addView(ETpoint[i]);
				}
				else
				{
					dyn_linearLayout[i].addView(PointSpinner[i]);
					
				}
					
				dyn_linearLayout[i].addView(ETmaal[i]);
				dyn_linearLayout[i].addView(won[i]);
				
				linearlayout.addView(dyn_linearLayout[i]);
			
		}
		
		selectedID =100;
		try{
			won[0].setChecked(true);
			
			if(valuebook.gamemode==0)
			{
				ETpoint[0].setText("0");
				ETpoint[0].setEnabled(false);
			}else{
				PointSpinner[0].setSelection(0);
				PointSpinner[0].setEnabled(false);
			}
		}catch(ArrayIndexOutOfBoundsException e)
		{
			Log.i("arrayout of bound in scoreentry", e.toString());
		}
			
		
		
		
		for (RadioButton button : radioButtons){

		    button.setOnCheckedChangeListener(new OnCheckedChangeListener(){
		        
		        public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
		            if (isChecked)
		            	processRadioButtonClick(buttonView);
		        }

				private void processRadioButtonClick(CompoundButton buttonView) {
					for (RadioButton button : radioButtons){

				        if (button != buttonView ) 
				        {
				        	button.setChecked(false);
				        	int id = button.getId();
				        	int position = id-100;
				        	
				        	if(valuebook.gamemode==0)
				        	{
				        		
				        		ETpoint[position].setEnabled(true);
					        	ETpoint[position].setText("");
				        	}else{
//				        		PointSpinner[position].setSelection(1);
				        		PointSpinner[position].setEnabled(true);
				        	}
				        	
				        }
				        else{
				        	selectedID = button.getId();
				        	int val = selectedID-100;
				        	if(valuebook.gamemode == 0)
				        	{
				        		ETpoint[val].setText("0");
				        		ETpoint[val].setEnabled(false);
				        	}
				        	else{
				        		PointSpinner[val].setSelection(0);
				        		PointSpinner[val].setEnabled(false);
				        	}
				        		
				        }
				        	
				    }
					
				}   
		    });

		}
		
				
		save.setOnClickListener(new View.OnClickListener() {
			
			int round;
			int playerid;
			int point;
			int maal;
			int won_who;
			
			String[] Spoint;
			String[] Smaal;
			
			int counter;
			
			public void onClick(View v) {
				
				counter=0;
				
				Spoint = new String[number_of_player];
				Smaal = new String[number_of_player];
				
				for(int i=0; i<number_of_player; i++){
					
					if(valuebook.gamemode==0)
					{
						Spoint[i] = ETpoint[i].getText().toString();						
					}else{
						Spoint[i] =  PointSpinner[i].getSelectedItem().toString();
					}
					
					Smaal[i] = ETmaal[i].getText().toString();
					
					if(Spoint[i].matches("") || Smaal[i].matches("")|| Integer.parseInt(Smaal[i]) ==1 )
					{
						counter++;
//						if(valuebook.gamemode ==0)
//						{
//							Drawable d = getResources().getDrawable(R.drawable.error_edittext);
//							ETpoint[i].setBackgroundDrawable(d);
//							
//						}
						//blank field lai red mark garne..
					}
					
				}
				
				if(counter>0)
				{
					Toast.makeText(getApplicationContext(), "Oops Mike! Either there is blank field or error with entry(maal should be >1)", Toast.LENGTH_SHORT).show();
				}else{
					CenterCollectionDatabase db = null;
					try{
							db = new CenterCollectionDatabase(ScoreEntry.this);
							db.open();
							int wnID = selectedID-100;
							
							for(int i=0; i<number_of_player; i++)
							{
								round = valuebook.round;
								playerid = i;
								point = Integer.parseInt(Spoint[i]);
								maal = Integer.parseInt(Smaal[i]);
									if(i == wnID)
									{
										won_who = 1;
									}
									else{
										won_who = 0;
									}
													
								db.add_score(round, playerid, point, maal, won_who);
							
							}
							
		
							valuebook.Roundup();
							
							
							Toast.makeText(getApplicationContext(), "Record Sucessfully Saved", Toast.LENGTH_SHORT).show();
							
							Intent intent = new Intent(ScoreEntry.this, ScoreBoard.class);
							startActivity(intent);
							overridePendingTransition(R.anim.in_from_left, R.anim.out_to_right );
							finish();
						
						}catch(SQLException e){
							
							valuebook.Rounddown();
							Toast.makeText(getApplicationContext(), "Lau ja crash po bhayo... Feri data enter gardim na te!!", Toast.LENGTH_SHORT).show();
							Intent intent = new Intent(ScoreEntry.this, ScoreBoard.class);
							startActivity(intent);
							finish();
						}finally{
							db.close();
						}
						
				}
				
			}
		});
		
	}

	@Override
	public void onBackPressed() {
//		super.onBackPressed();
		Intent intent = new Intent(ScoreEntry.this, ScoreBoard.class);
		startActivity(intent);
		finish();
	}
	

}
